# Engine Guide

## zh-CN

### 基本概念

JSVM由这些组件构成：

* `JSVM`
* `JSEnv`
* 各类Rt

JSVM即JS解释器，JSEnv提供暴露到JS运行时环境可以调用的各类对象、函数等，
这些对象、函数由各类Rt包提供，本项目提供了这些Rt包：

* `Runtime`
* `Logger`
* `Nest`

可以将这些Rt包按需注册到JSEnv，也可以模仿它们自行编写所需的Rt包并注册
到JSEnv。这些Rt包文件名以`js_rt_`为前缀，其文档在`docs/js/`下，
文档文件名为`Rt.<RtName>.<Locale>.md`的格式。

`Nest`是一个有些特殊的Rt包，它提供类似`JSEnv`的接口，可以在上面注册其他的Rt包，
以实现Rt包的嵌套功能。

### 其他依赖说明

#### 日志

依赖`git.swzry.com/zry/GoHiedaLogger/hiedalog`

使用方法详见示例。

#### 文件系统

依赖`github.com/spf13/afero`

参考示例或查看该项目官方的文档。

### 示例

请前往`example\cmd`查看示例。该示例包含一个简单的可以运行的引擎代码，
以及一个webpack工程，将新版本ECMAScript转换到该引擎支持的ECMScript 5。

在`example`目录使用`make`完成编译。

注意：若在非Windows环境编译，输出的可执行文件名称含有`.exe`后缀，
但不影响使用。

参考:

#### Unix/Unix Like

```bash
make all
chmod +x dist/jsvm-test.exe
./dist/jsvm-test.exe
```

#### Windows

注意需要安装make，可以使用`MSYS`等工具，在此不赘述。

```powershell
make all
.\dist\jsvm-test.exe
```

## en-US

