# Rt: Logger

## Description

该Rt提供简易的日志系统。有些像是CommonJS的`console`，但不太一样，
是它的一个简易版本。

它含有`debug`, `trace`, `info`, `warn`, `error`五个日志级别，
每个级别均有对应的相同名称的方法。

方法`log()`等效于`info()`，API Reference以`log()`为例介绍用法。

由于解释器由go写成，为了简单处理日志输出，没有完全模仿node.js或者
web浏览器上`console`的输出行为，而是直接将每个传入的输入参数
（对于goja解释器而言会转化为go的类型`goja.Value`），然后调用初始化时
传入的`LogFunc`
（原型：

```func(level JSRtLoggerLogLevel, info []goja.Value)```

）

该Rt在go端还提供了`JSRtLoggerLogFuncFromHiedaLogger`函数，
可以将`hiedalog.HiedaLogger`包装成`LogFunc`的类型。

它只是简单地把所有的`goja.Value`类型的参数，调用其方法`String()`，
转化为字符串，再传入HiedaLogger的`LogPrint`方法，
所以输出结构会类似于go的`fmt.Sprint`的效果。

例如，`log("a", "b", "c")`，在通常的js的`console.log()`下，
会显示为：

```
a b c
```

但是在这里，显示为：

```
abc
```

所以，请自行添加必要的空格，就像使用go的`fmt.Sprint`那样。

使用`JSRtLoggerLogFuncFromHiedaLogger`时，日志等级对应关系：

* `debug` (`debug()`) => `hiedalog.DLN_INFO`
* `trace` (`trace()`) => `hiedalog.DLN_VERBOSE`
* `info` (`info()` `log()`) => `hiedalog.DLN_INFO`
* `warn` (`warn()`) => `hiedalog.DLN_WARN`
* `error` (`error()`) => `hiedalog.DLN_ERROR`

## API Reference

### log(...)

参数可以是任意数量的任何内容。

### ...
不再赘述。
