# Rt: Rumtime

## Description

该Rt提供一些基本的运行时功能，暴露到JS环境中。

## API Reference

### quit(...)

为了确保退出容易执行成功，它接受任何类型参数。

当该函数被调用时，向解释器发送一个Interrupt，将会结束当前解释器实例的运行。

若在`setup`或`clenaup`中调用，在go这侧，`ExecSetup`或`ExecCleanup`将会返回
`Err_JSVMAbortByInterruit`，由go这侧程序决定接下来的行为。

若在`loop`中调用，则主循环退出，`RunLoop`函数返回`nil`，不会返回错误。
（因为除非受到Interrup，主循环是会不断进行的，所以此时调用quit视为一种正常的退出行为）

### sleep(int64 timeMs)

睡眠，单位为毫秒，将被转化为int64，故需传入符合范围的整数。

### getScope() -> string

获取当前执行的scope，返回值可能为以下值：

* `load`
* `setup`
* `loop`
* `cleanup`