const path = require('path');
const webpack = require('webpack');

module.exports = {
  entry: './src/index.js',
  output: {
    filename: 'main.js',
    path: path.resolve(__dirname, '../dist/js-dist/'),
    asyncChunks: false,
    chunkFormat: "commonjs",
    libraryExport: 'default',
    library: {
      type: "commonjs2",
    },

  },
  //mode: 'development',
  mode: 'production',
  target: 'es5',
  devtool: false,
  plugins: [
    new webpack.optimize.LimitChunkCountPlugin({
      maxChunks: 1,
    }),
  ],
};
